; Michael Seibert's mini-game
; this started out as the smiley prgm,
; and now im converting it to a game
;
; TODO:
; fix down-left bug
; add enemies
; add levels
; don't mess anything up :)


#include "ti86asm.inc"
.org _asm_exec_ram

;Shell Title
  nop
  jp ProgStart

.dw 0, ShellTitle

ProgStart:
  call ClearScreenFast      ; clear the screen
  ld bc,ShipCoord           ; load the coordinates
  ld ix,Ship                ; ix points to the sprite
  call DrawSprite           ; Draw the sprite bc=x,y; ix points to sprite
  
  ld b,2                    ; for the every other time loop
   
LoopStart:
  push bc                   ; ditto
  ld a,%00111111            ; bitmask for Exit/Second keys
  out (1),a                 ; send it to keypad
  ld d,255
InnerLoop1:
  nop                       ; wait for keypad to get info on keys
  nop
  nop
  nop
  dec d
  jr nz,InnerLoop1
  in a,(1)                  ; get value from keypad
  bit 6,a                   ; and test bit 6 for the exit key
  jp z,End                  ; if it is cleared Exit has
                            ; been pressed, so exit program
  bit 5,a                   ; test for Second key (to fire a shot)
  call z,FireAShot          ; call the fire a shot function
  call SecondKeyUp          ; 2nd key is not down, reset switch
  
  ld a,%01111110            ; bitmask for Arrows
  out (1),a                 ; send it to keypad
  ld d,255
InnerLoop2: 
  nop                       ; wait for keypad to get info on keys
  nop
  nop
  nop
  dec d
  jr nz,InnerLoop2
  in a,(1)                  ; get value from keypad  
  
  ld d,a                    ; save the value of arrows down
  
  bit 0,a                   ; If they pressed down...
  call z,Down               ; then call the down function
  ld a,d                    ; retrieve the arrows that are down
  
  bit 1,a                   ; If they pressed left...
  call z,Left               ; then call the left function
  ld a,d                    ; retrieve the arrows that are down
  
  bit 2,a                   ; If they pressed right...
  call z,Right              ; then call the right function
  ld a,d                    ; retrieve the arrows that are down
  
  bit 3,a                   ; If they pressed up...
  call z,Up                 ; then call the up function
  
  ;call ClearScreenFast
  
  ld bc,(ShipCoord)
  ld ix,Ship                ; load up the sprite..
  call DrawSprite           ; i think this is self explanatory
  
  ; draw the shots...
  
  pop bc                    ; get value of b
  
  djnz LoopStart            ; every other time darw the lasers....
  
  ld a,(LasersInUse)        ; load up which lasers are on the screen
  
  rrca                      ; if laser 1 is in use
  call c,DrawShot1          ; then draw the laser
  
  rrca                      ; if laser 2 is in use
  call c,DrawShot2          ; then draw the laser
  
  rrca                      ; if laser 3 is in use
  call c,DrawShot3          ; then draw the laser
  
  rrca                      ; if laser 4 is in use
  call c,DrawShot4          ; then draw the laser
  
  rrca                      ; if laser 5 is in use
  call c,DrawShot5          ; then draw the laser
  
  ld b,2                    ; load up b with to to keep every other time loop going...
                            ; it is pushed back on the stack at beginning of loop so
                            ; dont need to do it here
  
  jr LoopStart              ; Go back and do it all again

Down:
  ld hl,ShipY
  ld a,(hl)
  cp $37                    ; keep the ship from going down off the screen....
  ret z
  inc (hl)                  ; increment y (coordinates go from top left)
  ret                       ; return
Left:
  ld hl,ShipX
  ld a,(hl)
  or a                      ; keep the ship from going down left the screen....
  ret z
  dec (hl)                  ; decrement x
  ret                       ; return
Right:
  ld hl,ShipX
  ld a,(hl)
  cp 120                    ; keep the ship from going right off the screen....
  ret z
  inc (hl)                  ; increment x
  ret                       ; return
Up:
  ld hl,ShipY
  ld a,(hl)
  cp $1f                    ; keep the ship from going too far up(half screen)....
  ret z
  dec (hl)                  ; decrement y (coordinates go from top left)
  ret                       ; return
  
FireAShot:
  push af                   ; because of the weird way i did the calls this is necessary
  call RealFireAShot        ; call the function that ACTUALLY FIRES THE SHOT
  pop af                    ; ditto
  ret

RealFireAShot:
  ld a,(SecondKeyDown)
  or a                      ; see if a equals zero
  jr z,DrawIt               ; and draw the laser if is
  ld hl,SecondKeyDown       ; otherwise a shot has been fired previously
  ld (hl),10                ; so we reset the is 2nd down loop
  ret
DrawIt:
  ld hl,SecondKeyDown       ; reset the is 2nd down loop
  ld (hl),10                ; ditto
  ld bc,(ShipCoord)         ; load up the starting coordinates
  ld ix,ShotMap             ; load up the laser graphic
  call DrawSprite           ; Draw the laser graphic
  ld a,(LasersInUse)        ; find a laser thats not in use...
  
  rrca                      ; if laser 1 is free
  jr nc,SetShot1            ; then set it up with the coordinates
  
  rrca                      ; if laser 2 is free
  jr nc,SetShot2            ; then set it up with the coordinates
  
  rrca                      ; etc.
  jr nc,SetShot3
  
  rrca                      ; etc.
  jr nc,SetShot4
  
  rrca                      ; etc. 
  jr nc,SetShot5
  
  ret                       ; return not necesary, but we do it 
                            ; just in case all laser coordinate 
                            ; holders were full
                            
SetShot1:
  ld a,(LasersInUse)
  or %00000001
  ld (LasersInUse),a
  ld bc,(ShipCoord)
  ld (Laser1),bc
  ret
  
  
SetShot2:
  ld a,(LasersInUse)
  or %00000010
  ld (LasersInUse),a
  ld bc,(ShipCoord)
  ld (Laser2),bc
  ret
  
  
SetShot3:
  ld a,(LasersInUse)
  or %00000100
  ld (LasersInUse),a
  ld bc,(ShipCoord)
  ld (Laser3),bc
  ret
  
  
SetShot4:
  ld a,(LasersInUse)
  or %00001000
  ld (LasersInUse),a
  ld bc,(ShipCoord)
  ld (Laser4),bc
  ret
  
  
SetShot5:
  ld a,(LasersInUse)
  or %00010000
  ld (LasersInUse),a
  ld bc,(ShipCoord)
  ld (Laser5),bc
  ret
  
DrawShot1:
  push af
  ld hl,Laser1
  dec (hl)  
  ld bc,(Laser1)
  ld ix,ShotMap
  call DrawSprite
  ld a,(Laser1)
  cp 250
  call z,Disable1
  pop af
  ret
  
Disable1:
  ld a,(LasersInUse)
  and %11111110
  ld (LasersInUse),a
  ret
  
  
DrawShot2:
  push af
  ld hl,Laser2
  dec (hl)  
  ld bc,(Laser2)
  ld ix,ShotMap
  call DrawSprite
  ld a,(Laser2)
  cp 250
  call z,Disable2
  pop af
  ret
  
Disable2:
  ld a,(LasersInUse)
  and %11111101
  ld (LasersInUse),a
  ret
  
  
DrawShot3:
  push af
  ld hl,Laser3
  dec (hl)  
  ld bc,(Laser3)
  ld ix,ShotMap
  call DrawSprite
  ld a,(Laser3)
  cp 250
  call z,Disable3
  pop af
  ret
  
Disable3:
  ld a,(LasersInUse)
  and %11111011
  ld (LasersInUse),a
  ret
  
  
DrawShot4:
  push af
  ld hl,Laser4
  dec (hl)  
  ld bc,(Laser4)
  ld ix,ShotMap
  call DrawSprite
  ld a,(Laser4)
  cp 250
  call z,Disable4
  pop af
  ret
  
Disable4:
  ld a,(LasersInUse)
  and %11110111
  ld (LasersInUse),a
  ret
  
  
DrawShot5:
  push af
  ld hl,Laser5
  dec (hl)  
  ld bc,(Laser5)
  ld ix,ShotMap
  call DrawSprite
  ld a,(Laser5)
  cp 250
  call z,Disable5
  pop af
  ret

Disable5:
  ld a,(LasersInUse)
  and %11101111
  ld (LasersInUse),a
  ret
  
  
SecondKeyUp:
  ;ld hl,_curRow
  ;ld (hl),0
  ;ld hl,_curCol            ; look at all this stuff i had to do while debugging... *sigh*
  ;ld (hl),0
  ;ld h,0
  ;ld l,a
  ;xor a
  ;call _dispAHL
  ld a,(SecondKeyDown)
  ;xor a
  or a
  ret z
  dec a
  ld (SecondKeyDown),a
  ret
End:
  call _clrScrn
  ret                       ; return from the prgm or 2ndkeyup func

DrawSprite:
  ld hl, BackGroundBuffer
  call PutSprite            ; Draw the sprite bc = x,y; ix points to sprite
  ret
  
ClearScreenFast:
  ld hl,$fc00
  ld (hl),l
  ld de,$fc01
  ld bc,1023
  ldir
  ret


    
Ship:                        ; the ship that we draw on the screen
.db %00000000
.db %01000010
.db %01000010
.db %01000010
.db %01011010
.db %01100110
.db %01000010
.db %00000000
.db %11100111
.db %11100111
.db %11100111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11100111

ShotMap:
.db %00011000
.db %00011000
.db %00011000
.db %00011000
.db %00011000
.db %00011000
.db %00000000
.db %00000000
.db %00011000
.db %00011000
.db %00011000
.db %00011000
.db %00011000
.db %00011000
.db %00011000
.db %00000000

BackGroundBuffer:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000


ShipCoord:
ShipY:
.db $37
ShipX:
.db $3f

LasersInUse:
.db 0

Laser1:
.dw 0

Laser2:
.dw 0

Laser3:
.dw 0

Laser4:
.dw 0

Laser5:
.dw 0

SecondKeyDown:
.db 00000000


ShellTitle:
.db "Mini Game by Michael Seibert",0    ; the title of this program


#include "zmrbw.asm"                      ; needed for clearsprite function

.end



